//--------------------------------------------------------------------//
// {mC}

var canvas;				// LoXvf
var context;	 			// ReLXg
var pressed;				// }EX{^
var mx,my;				// }EXʒu
var points=[];				// _Xg
var edges=[];				// hl[ӃXg
var viewMode;				// \[h
var viewType;				// \}`̎

var POINT_R=2,POINT_R2=POINT_R*POINT_R;	// _̕`攼a
var OUT_SCREEN=10;			// ʊỎ_\W
var ARROW=6;				// L̖̕`TCY

// Ot̃rbg
var BITS={vd:1,gabriel:4,relne:8,nearest:16,nearest2:32,mstree:64};

// \[h
var EDIT_MODE=1;			// _ҏW[h
var DIAGRAM_MODE=2;			// }`惂[h

// \F
var BG_COLOR='rgb(255,255,255)';	// wiF
var PT_COLOR='rgb(0,0,0)';		// _\F
var DIAG_COLOR='rgb(255,0,0)';		// e}\F
var VORONOI_COLOR='rgb(0,0,255)';	// {mC}\F

// {mC}
function initVoronoi(){
  initCanvas();
  setType();
}

// LoX
function initCanvas(){
  canvas=document.getElementById('diagram');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  canvas.addEventListener('mousedown',mousePressed,false);
  canvas.addEventListener('mouseup',mouseReleased,false);
  document.addEventListener('keydown',keyPressed,false);
  context=canvas.getContext('2d');
  pressed=false;
  mx=0;
  my=0;
  viewMode=EDIT_MODE;
}

// }EX{^̏s
function mousePressed(e){
  pressed=true;
  mx=e.clientX;
  my=e.clientY;
  var rect=e.target.getBoundingClientRect();
  addPoint(mx-rect.left,my-rect.top);
  draw();
}

// }EX{^𗣂̏s
function mouseReleased(e){
  pressed=false;
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 12:		// (Numpad5 Off)
    case 53:		// 5
    case 67:		// C
    case 101:		// Numpad5 On
      createDiagram();
      break;
    case 68:		// D
      clearPoints();
      break;
  }
}

// _ǉ
// x,y - ǉ_̍W
function addPoint(x,y){
  if(viewMode==EDIT_MODE){
    var p=new Point(x,y);
// ̓_̖TO
    for(var i=0;i<points.length;i++){
      if(points[i].distanceSq(p)<POINT_R2){
      	return;
      }
    }
    points.push(p);
    draw();
  }
}

// {mC}Ehl[쐬
function createVoronoi(){
  edges.length=0;
  for(var i=0;i<points.length-1;i++){
    for(var j=i+1;j<points.length;j++){
      var line1=bisector(points[i],points[j]);
      var dx11=line1.x2-line1.x1;
      var dy11=line1.y2-line1.y1;
      var sw=true;
      for(var k=0;k<points.length;k++){
      	if((k!=i) && (k!=j) && sw){
      	  var line2=bisector(points[i],points[k]);
      	  var x0=line2.x1,y0=line2.y1;
      	  var dx21=line2.x2-x0;
      	  var dy21=line2.y2-y0;
      	  var sw1=dy21*(line2.x2-line1.x1)-dx21*(line2.y2-line1.y1);
      	  var sw2=dy21*dx11-dx21*dy11;
// słȂꍇ
      	  if(Math.abs(sw2)>0){
      	    var sw3=dx21*(points[i].y-y0)-dy21*(points[i].x-x0);
      	    var sw4=sw3*(dx21*(line1.y1-y0)-dy21*(line1.x1-x0));
      	    var sw5=sw3*(dx21*(line1.y2-y0)-dy21*(line1.x2-x0));
      	    sw1/=sw2;
      	    var xt=line1.x1+sw1*dx11;
      	    var yt=line1.y1+sw1*dy11;
// I_ύX
      	    if((sw4>0.0) && (sw5<0.0)){
      	      line1.x2=xt;
      	      line1.y2=yt;
      	    }
// n_ύX
      	    else if((sw4<0.0) && (sw5>0.0)){
      	      line1.x1=xt;
      	      line1.y1=yt;
      	    }
// {mCӂ
      	    else if((sw4<0.0) && (sw5<0.0)){
      	      sw=false;
      	    }
      	  }
      	}
      }
// {mC_̒_̋mF
      for(k=0;k<points.length;k++){
      	if((k!=i) && (k!=j) && sw){
      	  var sw6=points[k].distanceSqXY(line1.x1,line1.y1);
      	  var sw7=points[i].distanceSqXY(line1.x1,line1.y1);
      	  var sw8=points[k].distanceSqXY(line1.x2,line1.y2);
      	  var sw9=points[i].distanceSqXY(line1.x2,line1.y2);
      	  if((sw6<sw7) || (sw8<sw9)) sw=false;
      	}
      }
// {mCӁEhl[ӂ
      if(sw){
      	edges.push(new Edge(i,j,new Point(line1.x1,line1.y1),
      	      	      	    new Point(line1.x2,line1.y2),
      	      	      	    points[i].distanceSq(points[j])));
      }
    }
  }
// hl[ӂZɕבւ
  edges.sort(function(e1,e2){
    if(e1.length2<e2.length2)      return -1;
    else if(e1.length2>e2.length2) return 1;
    else                           return 0;
  });
}

// KuGOt쐬
function createGabrielGraph(){
  var bit=BITS.gabriel;
  for(var i=0;i<edges.length;i++){
    var x1=parseInt(edges[i].v1.x);
    var y1=parseInt(edges[i].v1.y);
    var dx=parseInt(edges[i].v2.x)-x1;
    var dy=parseInt(edges[i].v2.y)-y1;
    var sp=points[edges[i].start];
    var ep=points[edges[i].end];
    var f1=(ep.y-sp.y)*(ep.x-x1)-(ep.x-sp.x)*(ep.y-y1);
    var f2=dx*(ep.y-y1)-dy*(ep.x-x1);
    var f3=dx*(ep.y-sp.y)-dy*(ep.x-sp.x);
// {mCӂƃhl[ӂꍇ
    if(((f1>0) && (f2>0) && (f3>f1) && (f3>f2))
    || ((f1<0) && (f2<0) && (f3<f1) && (f3<f2))){
      edges[i].addBit(bit);
    }
  }
}

// ΋ߖTOt쐬
function createRelNeGraph(){
  var bit=BITS.relne;
  for(var i=0;i<edges.length;i++){
    var sp=points[edges[i].start];
    var ep=points[edges[i].end];
    edges[i].addBit(bit);
    var sw=true;
    for(var j=0;j<points.length;j++){
      if((j!=edges[i].start) && (j!=edges[i].end) && sw){
      	var dlarge=parseInt(Math.max(points[j].distanceSq(sp),
      	      	      	      	     points[j].distanceSq(ep)));
      	if(dlarge<edges[i].length2){
      	  edges[i].addBit(-bit);
      	  sw=false;
      	}
      }
    }
  }
}

// ŋߖTOt쐬
function createNearestGraph(){
  var bit1=BITS.nearest,bit2=BITS.nearest2;
  for(var i=0;i<points.length;i++){
    var distMin=Number.MAX_VALUE;
    var nearest=0;
// ŋߖT_T
    for(var j=0;j<points.length;j++){
      if(j!=i){
      	var dist=points[i].distanceSq(points[j]);
      	if(dist<distMin){
      	  distMin=dist;
      	  nearest=j;
      	}
      }
    }
    for(j=0;j<edges.length;j++){
// 
      if((edges[j].start==i) && (edges[j].end==nearest)){
      	edges[j].addBit(bit1);
      }
// t
      else if((edges[j].start==nearest) && (edges[j].end==i)){
      	edges[j].addBit(bit2);
      }
    }
  }
}

// ŏS؂쐬
function createMinimumSpanTree(){
  var bit=BITS.mstree;
  var msTree=new MSTree(points.length);
  var msEdgesCount=0;
  for(var i=0;i<edges.length;i++){
    if(msEdgesCount>=points.length-1) return;
// TCNȂꍇ
    if(msTree.isCycle(edges[i])){
      msEdgesCount++;
      edges[i].addBit(bit);
      msTree.setCycle(edges[i]);
    }
  }
}

// 2Ԃ
// p1,p2 - ̓_
function bisector(p1,p2){
  return linePoint(0.5*(p1.x+p2.x),0.5*(p1.y+p2.y),p2.y-p1.y,p1.x-p2.x);
}

// [Ԃ
// x,y - ʉߓ_̍W
// dx,dy - xNg̐
function linePoint(x,y,dx,dy){
  var ymin=-OUT_SCREEN*canvas.height;
  var ymax=(OUT_SCREEN+1)*canvas.height;
// 
  if(dx===0){
    return new Line(x,ymin,x,ymax);
  }
// ̑̏ꍇ
  else{
    var coef=dy/dx;
    var x1=-OUT_SCREEN*canvas.width;
    var y1=coef*(x1-x)+y;
    var x2=(OUT_SCREEN+1)*canvas.width;
    var y2=coef*(x2-x)+y;
    if(y1<ymin){
      x1=(ymin-y)/coef+x;
      y1=ymin;
    }
    else if(y1>ymax){
      x1=(ymax-y)/coef+x;
      y1=ymax;
    }
    if(y2<ymin){
      x2=(ymin-y)/coef+x;
      y2=ymin;
    }
    else if(y2>ymax){
      x2=(ymax-y)/coef+x;
      y2=ymax;
    }
    return new Line(x1,y1,x2,y2);
  }
}

// `悷
function draw(){
  context.fillStyle=BG_COLOR;
  context.fillRect(0,0,canvas.width,canvas.height);
  drawPoints();
  if(viewMode==DIAGRAM_MODE){
    if(viewType==BITS.nearest){
      drawNearest();
    }
    else{
      drawDiagrams();
      if(viewType==BITS.vd){
      	drawVoronoi();
      }
    }
  }
}

// _`悷
function drawPoints(){
  context.fillStyle=PT_COLOR;
  for(var i=0;i<points.length;i++){
    context.beginPath();
    context.arc(points[i].x,points[i].y,POINT_R,0,2*Math.PI,false);
    context.closePath();
    context.fill();
  }
}

// hl[}`悷
function drawDiagrams(){
  context.strokeStyle=DIAG_COLOR;
  context.beginPath();
  var base=2*viewType;
  for(var i=0;i<edges.length;i++){
    if(edges[i].isDraw(viewType,base)){
      var sp=points[edges[i].start];
      var ep=points[edges[i].end];
      context.moveTo(sp.x,sp.y);
      context.lineTo(ep.x,ep.y);
    }
  }
  context.closePath();
  context.stroke();
}

// ŋߖTOt`悷
function drawNearest(){
  var bit1=BITS.nearest,bit2=2*bit1,bit3=4*bit1;
  context.strokeStyle=DIAG_COLOR;
  context.beginPath();
  for(var i=0;i<edges.length;i++){
    if(edges[i].isDraw(bit1,bit2)){
      drawDirSegment(edges[i].start,edges[i].end);
    }
    if(edges[i].isDraw(bit2,bit3)){
      drawDirSegment(edges[i].end,edges[i].start);
    }
  }
  context.closePath();
  context.stroke();
}

// {mC}`悷
function drawVoronoi(){
  context.strokeStyle=VORONOI_COLOR;
  context.beginPath();
  for(var i=0;i<edges.length;i++){
    context.moveTo(edges[i].v1.x,edges[i].v1.y);
    context.lineTo(edges[i].v2.x,edges[i].v2.y);
  }
  context.closePath();
  context.stroke();
}

// L`悷
// sp,ep - n_EI_̃|C^
function drawDirSegment(sp,ep){
  var x1=points[sp].x,y1=points[sp].y,x2=points[ep].x,y2=points[ep].y;
  context.moveTo(x1,y1);
  context.lineTo(x2,y2);
  var cx=0.5*(x1+x2),cy=0.5*(y1+y2);
  var dx=x1-cx,dy=y1-cy,cc=0.5*Math.sqrt(3),ss=0.5;
  var cd=ARROW/Math.sqrt(dx*dx+dy*dy);
  dx*=cd;
  dy*=cd;
  context.moveTo(cx+cc*dx-ss*dy,cy+ss*dx+cc*dy);
  context.lineTo(cx,cy);
  context.lineTo(cx+cc*dx+ss*dy,cy-ss*dx+cc*dy);
}

// \}`̎ނݒ肷
function setType(){
  viewType=BITS[document.getElementById('type').value];
  draw();
}

// }
function createDiagram(){
  viewMode=DIAGRAM_MODE;
  createVoronoi();
  createGabrielGraph();
  createRelNeGraph();
  createNearestGraph();
  createMinimumSpanTree();
  draw();
}

// _
function clearPoints(){
  viewMode=EDIT_MODE;
  points.length=0;
  edges.length=0;
  draw();
}

//--------------------------------------------------------------------//
// _
// x,y - _̍W
var Point=function(x,y){
  this.x=x;
  this.y=y;
};

// _Ƃ̋Ԃ
// p - 𑪂Ώۂ̓_
Point.prototype.distance=function(p){
  var dx=this.x-p.x;
  var dy=this.y-p.y;
  return Math.sqrt(dx*dx+dy*dy);
};

// _Ƃ̋2Ԃ
// p - 𑪂Ώۂ̓_
Point.prototype.distanceSq=function(p){
  var dx=this.x-p.x;
  var dy=this.y-p.y;
  return dx*dx+dy*dy;
};

// _Ƃ̋2Ԃ
// x,y - 𑪂Ώۂ̓_̍W
Point.prototype.distanceSqXY=function(x,y){
  var dx=this.x-x;
  var dy=this.y-y;
  return parseInt(dx*dx+dy*dy);
};

//--------------------------------------------------------------------//
// 
// x1,y1 - n_̍W
// x2,y2 - I_̍W
var Line=function(x1,y1,x2,y2){
  this.x1=x1;
  this.y1=y1;
  this.x2=x2;
  this.y2=y2;
};

//--------------------------------------------------------------------//
// hl[
// start,end - n_EI_|C^
// v1,v2 - {mC_
// length2 - ӂ̒2
var Edge=function(start,end,v1,v2,length2){
  this.start=start;
  this.end=end;
  this.v1=v1;
  this.v2=v2;
  this.length2=length2;
  this.code=1;		// ӂ̎
};

// ӂ̎ނύX
// bit - ӂ̃rbgl
Edge.prototype.addBit=function(bit){
  this.code+=bit;
};

// ӂ̎ނύX
// bit,bitBase - ӂ̃rbgl
Edge.prototype.isDraw=function(bit,bitBase){
  return (this.code%bitBase>=bit);
};

//--------------------------------------------------------------------//
// ŏS؃f[^
// count - _̐
var MSTree=function(count){
  this.cycle=[];
  this.next=[];
  this.size=[];
  for(var i=0;i<count;i++){
    this.cycle[i]=i;
    this.next[i]=i;
    this.size[i]=1;
  }
};

// TCNǂԂ
// edge - 
MSTree.prototype.isCycle=function(edge){
  return (this.cycle[edge.start]!=this.cycle[edge.end]);
};

// TCNݒ肷
// edge - 
MSTree.prototype.setCycle=function(edge){
  if(this.size[this.cycle[edge.start]]>this.size[this.cycle[edge.end]]){
    this.addCycle(edge.start,edge.end);
  }
  else{
    this.addCycle(edge.end,edge.start);
  }
};

// TCN
// v1,v2 - _ԍ
MSTree.prototype.addCycle=function(v1,v2){
  this.size[this.cycle[v1]]+=this.size[this.cycle[v1]];
  var v=v2;
  do{
    this.cycle[v]=this.cycle[v1];
    v=this.next[v];
  }while(v!=v2);
  v=this.next[v1];
  this.next[v1]=this.next[v2];
  this.next[v2]=v;
};
